<?php
/*
Author: Kieran O'Shea
Author URI: http://www.kieranoshea.com
Description: Admin panel for the calendar plugin
Version: 1.1
*/

require_once('admin.php');
$title = __('Calendar');
$parent_file = 'edit.php';

// Global variable cleanup. 
$edit = $create = $save = $delete = false;

// How to control the app
$action = !empty($_REQUEST['action']) ? $_REQUEST['action'] : '';
$event_id = !empty($_REQUEST['event_id']) ? $_REQUEST['event_id'] : '';

// Messages for the user
$debugText = '';
$messages = '';


require_once('admin-header.php');
//get_currentuserinfo();
?>

<style type="text/css">
<!--
	.error
	{
		background: lightcoral;
		border: 1px solid #e64f69;
		margin: 1em 5% 10px;
		padding: 0 1em 0 1em;
	}

	.center		{ text-align: center;	}
	.right		{ text-align: right;	}
	.left		{ text-align: left;		}
	.top		{ vertical-align: top;	}
	.bold		{ font-weight: bold;	}
	.private	{ color: #e64f69;		}
//-->
</style>

<?php

//
// Lets see if this is first run and create us a table if it is!
//
$tableExists = false;
$tables = $wpdb->get_results("show tables;");

foreach ( $tables as $table )
{
	foreach ( $table as $value )
	{
		if ( $value == WP_CALENDAR_TABLE )
		{
			$tableExists=true;
			break;
		}
	}
}

if ( !$tableExists )
{
	$sql = "CREATE TABLE `" . WP_CALENDAR_TABLE . "` (
				`event_id` INT(11) NOT NULL AUTO_INCREMENT ,
				`event_begin` DATE NOT NULL ,
				`event_end` DATE NOT NULL ,
				`event_title` VARCHAR(30) NOT NULL ,
				`event_desc` VARCHAR(255) NOT NULL ,
				`event_time` TIME ,
				`event_recur` CHAR(1) ,
				`event_repeats` INT(3) , 
				PRIMARY KEY ( `event_id` )
			)";
	$wpdb->get_results($sql);

	echo "<div class=\"updated\"><p><strong>Greetings</strong><br /><br />
This is the first time you have visited the admin page for calendar. The plugin has created a database table 
for you (" . WP_CALENDAR_TABLE . ") and all your events will be stored there. If you want 
to remove the data, make sure to delete that table after deactivating the plugin. 
This plugin's website is at <a href=\"http://www.kieranoshea.com/programming\">http://www.kieranoshea.com/programming</a></p></div>";
}
//
// First run stage finished
//


//
// Lets deal with the various functions
//
if ( $action == 'add' )
{
	$title = !empty($_REQUEST['event_title']) ? $_REQUEST['event_title'] : '';
	$desc = !empty($_REQUEST['event_desc']) ? $_REQUEST['event_desc'] : '';
	$begin = !empty($_REQUEST['event_begin']) ? $_REQUEST['event_begin'] : '';
	$end = !empty($_REQUEST['event_end']) ? $_REQUEST['event_end'] : '';
	$time = !empty($_REQUEST['event_time']) ? $_REQUEST['event_time'] : '';
	$recur = !empty($_REQUEST['event_recur']) ? $_REQUEST['event_recur'] : '';
	$repeats = !empty($_REQUEST['event_repeats']) ? $_REQUEST['event_repeats'] : '';
	
	// Deal with the fools who have left magic quotes turned on
	if ( ini_get('magic_quotes_gpc') )
	{
		$title = stripslashes($title);
		$desc = stripslashes($desc);
		$begin = stripslashes($begin);
		$end = stripslashes($end);
		$time = stripslashes($time);
		$recur = stripslashes($recur);
		$repeats = stripslashes($repeats);	
	}	

	$sql = "INSERT INTO " . WP_CALENDAR_TABLE . " SET event_title='" . mysql_escape_string($title)
	     . "', event_desc='" . mysql_escape_string($desc) . "', event_begin='" . mysql_escape_string($begin) 
             . "', event_end='" . mysql_escape_string($end) . "', event_time='" . mysql_escape_string($time) . "', event_recur='" . mysql_escape_string($recur) . "', event_repeats='" . mysql_escape_string($repeats) . "'";
	     
	$wpdb->get_results($sql);
	
	$sql = "SELECT event_id FROM " . WP_CALENDAR_TABLE . " WHERE event_title='" . mysql_escape_string($title) . "'"
		. " AND event_desc='" . mysql_escape_string($desc) . "' AND event_begin='" . mysql_escape_string($begin) . "' AND event_end='" . mysql_escape_string($end) . "' AND event_recur='" . mysql_escape_string($recur) . "' AND event_repeats='" . mysql_escape_string($repeats) . "' LIMIT 1";
	$result = $wpdb->get_results($sql);
	
	if ( empty($result) || empty($result[0]->event_id) )
	{
		?>
		<div class="error"><p><strong>Error:</strong> For some bizare reason your event was not added. Why not try again </p></div>
		<?php
	}
	else
	{
		?>
		<div class="updated"><p>Event added. It will now show in your calendar.</p></div>
		<?php
	}
}
elseif ( $action == 'edit_save' )
{
	$title = !empty($_REQUEST['event_title']) ? $_REQUEST['event_title'] : '';
	$desc = !empty($_REQUEST['event_desc']) ? $_REQUEST['event_desc'] : '';
	$begin = !empty($_REQUEST['event_begin']) ? $_REQUEST['event_begin'] : '';
	$end = !empty($_REQUEST['event_end']) ? $_REQUEST['event_end'] : '';
	$time = !empty($_REQUEST['event_time']) ? $_REQUEST['event_time'] : '';
	$recur = !empty($_REQUEST['event_recur']) ? $_REQUEST['event_recur'] : '';
	$repeats = !empty($_REQUEST['event_repeats']) ? $_REQUEST['event_repeats'] : '';
	
	// Deal with the fools who have left magic quotes turned on
	if ( ini_get('magic_quotes_gpc') )
	{
		$title = stripslashes($title);
		$desc = stripslashes($desc);
		$begin = stripslashes($begin);
		$end = stripslashes($end);
		$time = stripslashes($time);
		$recur = stripslashes($recur);
		$repeats = stripslashes($repeats);	
	}
	
	if ( empty($event_id) )
	{
		?>
		<div class="error"><p><strong>Failure:</strong> You can't update an event if you haven't submitted an event id</p></div>
		<?php		
	}
	else
	{
		$sql = "UPDATE " . WP_CALENDAR_TABLE . " SET event_title='" . mysql_escape_string($title)
		     . "', event_desc='" . mysql_escape_string($desc) . "', event_begin='" . mysql_escape_string($begin) 
                     . "', event_end='" . mysql_escape_string($end) . "', event_time='" . mysql_escape_string($time) . "', event_recur='" . mysql_escape_string($recur) . "', event_repeats='" . mysql_escape_string($repeats) . "'" . " WHERE event_id='" . mysql_escape_string($event_id) . "'";
		     
		$wpdb->get_results($sql);
		
		$sql = "SELECT event_id FROM " . WP_CALENDAR_TABLE . " WHERE event_title='" . mysql_escape_string($title) . "'"
		     . " AND event_desc='" . mysql_escape_string($desc) . "' AND event_begin='" . mysql_escape_string($begin) . "' AND event_end='" . mysql_escape_string($end) . "' AND event_recur='" . mysql_escape_string($recur) . "' AND event_repeats='" . mysql_escape_string($repeats) . "' LIMIT 1";
		$result = $wpdb->get_results($sql);
		
		if ( empty($result) || empty($result[0]->event_id) )
		{
			?>
			<div class="error"><p><strong>Failure:</strong> For some reason the event didn't update. Why not try again. </p></div>
			<?php
		}
		else
		{
			?>
			<div class="updated"><p>Event updated successfully</p></div>
			<?php
		}		
	}
}
elseif ( $action == 'delete' )
{
	if ( empty($event_id) )
	{
		?>
		<div class="error"><p><strong>Error:</strong> Good Lord you gave me nothing to delete, nothing I tell you!</p></div>
		<?php			
	}
	else
	{
		$sql = "DELETE FROM " . WP_CALENDAR_TABLE . " WHERE event_id='" . mysql_escape_string($event_id) . "'";
		$wpdb->get_results($sql);
		
		$sql = "SELECT event_id FROM " . WP_CALENDAR_TABLE . " WHERE event_id='" . mysql_escape_string($event_id) . "'";
		$result = $wpdb->get_results($sql);
		
		if ( empty($result) || empty($result[0]->event_id) )
		{
			?>
			<div class="updated"><p>Event deleted successfully</p></div>
			<?php
		}
		else
		{
			?>
			<div class="error"><p><strong>Error:</strong> For some bizare reason the event could not be deleted. Why not try again.</p></div>
			<?php

		}		
	}
}
//
// End of the functionality definitions
//

?>

<div class="wrap">
	<?php
	if ( $action == 'edit' )
	{
		?>
		<h2><?php _e('Edit Event'); ?></h2>
		<?php
		if ( empty($event_id) )
		{
			echo "<div class=\"error\"><p>Good lord you didn't provide an event id to edit, what were you thinking?</p></div>";
		}
		else
		{
			wp_events_edit_form('edit_save', $event_id);
		}	
	}
	else
	{
		?>
		<h2><?php _e('Add Event'); ?></h2>
		<?php wp_events_edit_form(); ?>
	
		<h2><?php _e('Manage Events'); ?></h2>
		<?php
			wp_events_display_list();
	}
	?>
</div>

<?php
include('admin-footer.php');


/**
 * Display code for the listing
 */
function wp_events_display_list()
{
	global $wpdb;
	
	$events = $wpdb->get_results("SELECT * FROM " . WP_CALENDAR_TABLE . " ORDER BY event_begin DESC");
	
	if ( !empty($events) )
	{
		?>
		<table width="100%" cellpadding="3" cellspacing="3">
			<tr>
				<th scope="col"><?php _e('ID') ?></th>
				<th scope="col"><?php _e('Title') ?></th>
				<th scope="col"><?php _e('Description') ?></th>
				<th scope="col"><?php _e('Start Date') ?></th>
				<th scope="col"><?php _e('End Date') ?></th>
				<th scope="col"><?php _e('Recurs') ?></th>
				<th scope="col"><?php _e('Repeats') ?></th>
				<th scope="col"><?php _e('Edit') ?></th>
				<th scope="col"><?php _e('Delete') ?></th>
			</tr>
		<?php
		$class = '';
		foreach ( $events as $event )
		{
			$class = ($class == 'alternate') ? '' : 'alternate';
			?>
			<tr class="<?php echo $class; ?>">
				<th scope="row"><?php echo $event->event_id; ?></th>
				<td><?php echo $event->event_title; ?></td>
				<td><?php echo $event->event_desc; ?></td>
				<td><?php echo $event->event_begin; ?></td>
				<td><?php echo $event->event_end; ?></td>
				<td>
				<?php 
					if ($event->event_recur == 'S') { echo 'Never'; } 
					else if ($event->event_recur == 'W') { echo 'Weekly'; }
					else if ($event->event_recur == 'M') { echo 'Monthly'; }
					else if ($event->event_recur == 'Y') { echo 'Yearly'; }
				?>
				</td>
				<td>
				<?php
					if ($event->event_recur == 'S') { echo 'N/A'; }
					else if ($event->event_repeats == 0) { echo 'Forever'; }
					else if ($event->event_repeats > 0) { echo $event->event_repeats.' Times'; }					
				?>
				</td>
				<td><a href="edit-calendar.php?action=edit&amp;event_id=<?php echo $event->event_id;?>" class='edit'><?php echo __('Edit'); ?></a></td>
				<td><a href="edit-calendar.php?action=delete&amp;event_id=<?php echo $event->event_id;?>" class="delete" onclick="return confirm('Are you sure you want to delete this event?')"><?php echo __('Delete'); ?></a></td>
			</tr>
			<?php
		}
		?>
		</table>
		<?php
	}
	else
	{
		?>
		<p><?php _e("There are no events in the database!") ?></p>
		<?php	
	}
}


/**
 * Display code for the add/edit form
 */
function wp_events_edit_form($mode='add', $event_id=false)
{
	global $wpdb;
	$data = false;
	
	if ( $event_id !== false )
	{
		if ( intval($event_id) != $event_id )
		{
			echo "<div class=\"error\"><p>Bad Monkey! No banana!</p></div>";
			return;
		}
		else
		{
			$data = $wpdb->get_results("SELECT * FROM " . WP_CALENDAR_TABLE . " WHERE event_id='" . mysql_escape_string($event_id) . "' LIMIT 1");
			if ( empty($data) )
			{
				echo "<div class=\"error\"><p>An event with that ID couldn't be found</p></div>";
				return;
			}
			$data = $data[0];
		}	
	}
	
	?>
	<form name="quoteform" id="quoteform" class="wrap" method="post" action="<?php echo $_SERVER['PHP_SELF']?>">
		<input type="hidden" name="action" value="<?php echo $mode?>">
		<input type="hidden" name="event_id" value="<?php echo $event_id?>">
	
		<div id="item_manager">
			<div style="float: left; width: 98%; clear: both;" class="top">
				<!-- List URL -->				
				<fieldset class="small"><legend><?php _e('Event Title'); ?></legend>
					<input type="text" name="event_title" class="input" size=30
					value="<?php if ( !empty($data) ) echo htmlspecialchars($data->event_title); ?>" />
				</fieldset>

				<fieldset class="small"><legend><?php _e('Event Description'); ?></legend>
					<input type="text" name="event_desc" class="input" size=50
					value="<?php if ( !empty($data) ) echo htmlspecialchars($data->event_desc); ?>" />
				</fieldset>

				<fieldset class="small"><legend><?php _e('Start Date'); ?></legend>
					<input type="text" name="event_begin" class="input" size=12
					value="
					<?php 
					if ( !empty($data) ) 
					{
						echo htmlspecialchars($data->event_begin);
					}
					else
					{
						echo date("Y-m-d");
					} 
					?>
					" />
				</fieldset>

				<fieldset class="small"><legend><?php _e('End Date'); ?></legend>
					<input type="text" name="event_end" class="input" size=12
					value="
					<?php 
					if ( !empty($data) ) 
					{
						echo htmlspecialchars($data->event_end);
					}
					else
					{
						echo date("Y-m-d");
					}
					?>" />
				</fieldset>

				<fieldset class="small"><legend><?php _e('Time (optional, set blank if not required)'); ?></legend>
					<input type="text" name="event_time" class="input" size=12
					value="
					<?php 
					if ( !empty($data) ) 
					{
						if ($data->event_time == "00:00:00")
						{
							echo '';
						}
						else
						{
							echo date("H:i",strtotime(htmlspecialchars($data->event_time)));
						}
					}
					else
					{
						echo date("H:i");
					}
					?>" />
				</fieldset>

				<fieldset class="small"><legend><?php _e('Recurring Events: '); ?></legend>
					<?php
					if ($data->event_repeats != NULL)
					{
						$repeats = $data->event_repeats;
					}
					else
					{
						$repeats = 0;
					}

					if ($data->event_recur == "S")
					{
						$selected_s = 'selected="selected"';
					}
					else if ($data->event_recur == "W")
					{
						$selected_w = 'selected="selected"';
					}
					else if ($data->event_recur == "M")
					{
						$selected_m = 'selected="selected"';
					}
					else if ($data->event_recur == "Y")
					{
						$selected_y = 'selected="selected"';
					}
					?>
					Repeats for 
					<input type="text" name="event_repeats" class="input" size=1 value="
					<?php echo $repeats; ?> 
					" /> 
					<select name="event_recur" class="input">
						<option class="input" <?php echo $selected_s; ?> value="S">None</option>
						<option class="input" <?php echo $selected_w; ?> value="W">Weeks</option>
						<option class="input" <?php echo $selected_m; ?> value="M">Months</option>
						<option class="input" <?php echo $selected_y; ?> value="Y">Years</option>
					</select><br />
					Entering 0 means forever. Where the recurrance interval <br />
					is left at none, the event will not reoccur.
				</fieldset>
				<br />
				<input type="submit" name="save" class="button bold" value="Save &raquo;" />
			</div>
			<div style="clear:both; height:1px;">&nbsp;</div>
		</div>
	</form>
	<?php
}

?>
